function [ENOB,SINAD]=dyn_calc(x,Fs,bit)

	
	L=length(x);
	t=(0:L-1)/Fs;
	
	figure(1)
	plot(Fs*t(1:50),x(1:50))
	title('Signal Corrupted with Zero-Mean Random Noise')
	xlabel('time (milliseconds)')
	NFFT = 2^(nextpow2(L)-1); % Next power of 2 from length of y
	x=x(L-NFFT:L);
	Y = fft(x,NFFT)/NFFT/2^bit;
	P=abs(Y.*Y);
	f = Fs/2*linspace(0,1,NFFT/2+1);
	fin=0;
	spanh=2;
	[devnull,index_fin]=max(P(1+spanh:NFFT))
	index_fin=index_fin+spanh
	fin=f(index_fin)
	P=abs(Y.*Y);
	Pdc=sum(P(1:1+spanh))
	Ps=sum(P(index_fin-spanh:index_fin+spanh))
	Pharm=zeros(1,7);
	for i=2:7
		if (index_fin*i -spanh< NFFT/2)
			if(index_fin*i+spanh<NFFT/2)
				Pharm(i)=sum(P(index_fin*i-spanh:index_fin*i+spanh));
			else
				Pharm(i)=sum(P(index_fin*i-spanh:NFFT/2));
			end
		end
	end
	
	Pharm
	Ph=sum(Pharm)
	Pn=sum(P(1:NFFT/2+1))-Ps-Pdc-Ph
	SNR=10*log10(Ps/Pn)
	THD=10*log10(Ph/Ps)
	SNDR=10*log10(Ps/(Pn+Ph))
	SINAD=10*log10((Ps+Pn+Ph)/(Pn+Ph))
	ENOB=(SNDR-1.76)/6.02
	SFDR=10*log10(Ps)-10*log10(max(Pharm))
	% Plot single-sided amplitude spectrum.

	length(Y)
	
	for i=1:length(Y)
		
		if Y(i)==0 && i>1
			Y(i)=Y(i-1);
		elseif Y(i)==0 &&i==1
			Y(i)=1e-9;
		end



	
		
	end
	P=abs(Y.*Y);
	figure(2)
	plot(f,10*log10((2*abs(P(1:NFFT/2+1))))-10*log10(Ps)) 
	title({'FFT';['SNR=',num2str(SNR),' SNDR=',num2str(SNDR),' ENOB=',num2str(ENOB)];['Fin=',num2str(fin,'%g'),' THD=',num2str(THD), ' SFDR=',num2str(SFDR)]})
	xlabel('Frequency (Hz)')
	ylabel('|Y(f)|')
	return


end
